%ifos darwin
%define __defattr       %defattr(-, root, wheel)
%define __soext         dylib
%define __libtool	/usr/bin/glibtool
%else
%define __defattr       %defattr(-, root, root)
%define __soext         so
%define __libtool	/usr/bin/libtool
%endif

Summary: Library providing XML and HTML support
Name: libxml2
Version: 2.4.25
Release: 2a
License: MIT
Group: Development/Libraries
Source: ftp://xmlsoft.org/libxml2-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-root
%ifnos darwin
BuildRequires: python python-devel
%endif
URL: http://xmlsoft.org/
Prefix: %{_prefix}
Docdir: %{_docdir}

%description
This library allows to manipulate XML files. It includes support 
to read, modify and write XML and HTML files. There is DTDs support
this includes parsing and validation even with complex DtDs, either
at parse time or later once the document has been modified. The output
can be a simple SAX stream or and in-memory DOM like representations.
In this case one can use the built-in XPath and XPointer implementation
to select subnodes or ranges. A flexible Input/Output mechanism is
available, with existing HTTP and FTP modules and combined to an
URI library.

%package devel
Summary: Libraries, includes, etc. to develop XML and HTML applications
Group: Development/Libraries
%ifnos darwin
Requires: zlib-devel
%endif
Requires: libxml2 = %{version}

%description devel
Libraries, include files, etc you can use to develop XML applications.
This library allows to manipulate XML files. It includes support 
to read, modify and write XML and HTML files. There is DTDs support
this includes parsing and validation even with complex DtDs, either
at parse time or later once the document has been modified. The output
can be a simple SAX stream or and in-memory DOM like representations.
In this case one can use the built-in XPath and XPointer implementation
to select subnodes or ranges. A flexible Input/Output mechanism is
available, with existing HTTP and FTP modules and combined to an
URI library.

%ifnos darwin
%package python
Summary: Python bindings for the libxml2 library
Group: Development/Libraries
Requires: libxml2 = %{version}
%ifnos darwin
Requires: python
%endif

%description python
The libxml2-python package contains a module that permits applications
written in the Python programming language to use the interface
supplied by the libxml2 library to manipulate XML files.

This library allows to manipulate XML files. It includes support 
to read, modify and write XML and HTML files. There is DTDs support
this includes parsing and validation even with complex DTDs, either
at parse time or later once the document has been modified.
%endif


%prep
%setup -q

%ifos darwin
cp -p configure configure.ORIG
sed -e 's;-undefined suppress;-undefined error;g' configure.ORIG > configure
chmod 755 configure
%endif


%build
# Needed for snapshot releases.
if [ ! -f configure ]; then
%ifarch alpha
  CFLAGS="$RPM_OPT_FLAGS" ./autogen.sh --host=alpha-redhat-linux --prefix=%prefix --sysconfdir="/etc" --mandir=%{_mandir} --libdir=%{_libdir}
%else
  CFLAGS="$RPM_OPT_FLAGS" ./autogen.sh --prefix=%prefix --sysconfdir="/etc" --mandir=%{_mandir} --libdir=%{_libdir}
%endif
else
%ifarch alpha
  CFLAGS="$RPM_OPT_FLAGS" ./configure --host=alpha-redhat-linux --prefix=%prefix --sysconfdir="/etc" --mandir=%{_mandir} --libdir=%{_libdir}
%else
  CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%prefix --sysconfdir="/etc" --mandir=%{_mandir} --libdir=%{_libdir}
%endif
fi

if [ "$SMP" != "" ]; then
  (make LIBTOOL=%{__libtool} "MAKE=make -k -j $SMP"; exit 0)
  make LIBTOOL=%{__libtool}
else
  make LIBTOOL=%{__libtool}
fi

%install
rm -rf $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{_mandir}/man1
install -d $RPM_BUILD_ROOT%{_mandir}/man4
%makeinstall
# make prefix=$RPM_BUILD_ROOT%{prefix} libdir=$RPM_BUILD_ROOT%{_libdir} mandir=$RPM_BUILD_ROOT%{_mandir} install

%ifnos darwin
#
# this is a bit ugly but tries to generate the bindings for all versions
# of python installed
for i in %{prefix}/include/python*
do
    py_version=`echo $i | sed "s+%{prefix}/include/python++"`
    if test -x %{prefix}/bin/python$py_version
    then
        echo generating bindings for Python $py_version
	(cd python ; make clean ; \
         make PYTHON="%{prefix}/bin/python$py_version" \
	      PYTHON_INCLUDES="%{prefix}/include/python$py_version" \
	      PYTHON_VERSION="$py_version"; \
         make PYTHON="%{prefix}/bin/python$py_version" \
	      PYTHON_INCLUDES="%{prefix}/include/python$py_version" \
	      PYTHON_VERSION="$py_version" \
	      prefix=$RPM_BUILD_ROOT%{prefix} \
	      libdir=$RPM_BUILD_ROOT%{_libdir} \
	      mandir=$RPM_BUILD_ROOT%{_mandir} install)
    fi
done
%endif


%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%{__defattr}

%doc AUTHORS ChangeLog NEWS README Copyright TODO
%doc %{_mandir}/man1/xmllint.1*
%doc %{_mandir}/man1/xmlcatalog.1*
%doc %{_mandir}/man3/libxml.3*

%ifos darwin
%{_libdir}/lib*.*.%{__soext}
%else
%{_libdir}/lib*.%{__soext}.*
%endif
%{prefix}/bin/xmllint
%{prefix}/bin/xmlcatalog

%files devel
%{__defattr}

%doc %{_mandir}/man1/xml2-config.1*
%doc AUTHORS ChangeLog NEWS README Copyright TODO
%doc doc/*.html doc/html doc/*.gif doc/*.png

%{_libdir}/libxml2.%{__soext}
%{_libdir}/*a
%{_libdir}/*.sh
%{prefix}/include/*
%{prefix}/bin/xml2-config
%{prefix}/share/aclocal/libxml.m4
%{_libdir}/pkgconfig/libxml-2.0.pc


%ifnos darwin
%files python
%{__defattr}

%doc AUTHORS ChangeLog NEWS README Copyright
%{_libdir}/python*/site-packages/libxml2.py
%{_libdir}/python*/site-packages/libxml2mod.%{__soext}
%doc python/TODO
%doc python/libxml2class.txt
%doc python/tests/*.py
%endif


%changelog
* Sat Oct 12 2002 Keisuke Fujii <fujiik@jlcuxf.kek.jp>
- Release 2.4.25-2a: 1st release on MacOS X 10.2.X.

* Fri Oct  4 2002 Jeremy Katz <katzj@redhat.com>
- build with 'make LIBTOOL=%{__libtool}' to use system libtool

* Wed Sep  4 2002 Daniel Veillard <veillard@redhat.com>

- library paths fixed for x86-64

* Fri Feb  1 2002 Daniel Veillard <veillard@redhat.com>

- Added the python package

* Sun Nov  4 2001 Daniel Veillard <veillard@redhat.com>

- cleaned up the specfile
- 2.4.7 broke SGML catalogs badly. this fixes it.

* Thu Apr 26 2001 Toshio Kuratomi <badger@prtr-13.ucsc.edu>

[2.3.7]
- Added libxml.m4 to the distribution file list
- Moved the man pages from /usr/man to /usr/share/man to conform to FHS2.0
- Moved programmer documentation into the devel package

* Thu Sep 23 1999 Daniel Veillard <daniel@veillard.com>

- corrected the spec file alpha stuff
- switched to version 1.7.1
- Added validation, XPath, nanohttp, removed memory leaks
- Renamed CHAR to xmlChar

* Wed Jun  2 1999 Daniel Veillard <daniel@veillard.com>

- Switched to version 1.1: SAX extensions, better entities support, lots of
  bug fixes.

* Sun Oct  4 1998 Daniel Veillard <daniel@veillard.com>

- Added xml-config to the package

* Thu Sep 24 1998 Michael Fulbright <msf@redhat.com>

- Built release 0.30

